var connect=false;
var added=0;
var dataCache=null;
var nbItem=0;
var subscriber=0;
var databaseFile=null;

exports.database = function() {
	if (connect==false) {
		var dbFile;
		if (Ti.Platform.name === 'android' && Ti.Filesystem.isExternalStoragePresent()) {
			var dbDir= Ti.Filesystem.getFile(Ti.Filesystem.externalStorageDirectory,'utpart');
			if (! dbDir.exists()) {
				dbDir.createDirectory();
			}
			dbDir= Ti.Filesystem.getFile(dbDir.nativePath,'database');
			if (! dbDir.exists()) {
				dbDir.createDirectory();
			}
  			databaseFile=dbDir.nativePath.substr(7) + Ti.Filesystem.separator + 'utpart';
		} else {
			databaseFile='utpart';
		}		
		dbFile=Ti.Database.open(databaseFile);
		var requete="CREATE TABLE IF NOT EXISTS requetes (param TEXT PRIMARY KEY, result TEXT, timeStamp NUMERIC )";
		var rs = dbFile.execute(requete);
		Ti.API.info('Database :'+databaseFile);
		dbFile.close();
		dataCache=new Array();
		nbItem=dataCacheRead();
		Ti.API.info('Database dataCacheRead:'+nbItem);
		connect=true;
		subscriber=1;
	} else {
		subscriber++;
		Ti.API.info('Database already open:'+subscriber);
	}
};

exports.database.prototype.requete = function(requete) {
	if (connect==false) return null;
	var db=Ti.Database.open(databaseFile);
	var rows=db.execute(requete);
	Ti.API.info('Row count: ' + rows.rowCount);
	Ti.API.info('Database result:'+rows);
	var res=[];
	var n=0;
	var fieldCount = rows.fieldCount;
	while (rows.isValidRow()){
		res[n]=new Array();
  		for (var i=0;i<fieldCount;i++) {
  			res[n][i]=rows.field(i);
  		}
  		n++;
  		rows.next();
	}
	rows.close();	
	return res;
}
exports.database.prototype.close = function(save) {
	if (save) {
		dataCacheWrite();
	}
}

exports.database.prototype.push = function(param,result) {
	dataCache.push({param:param,result:result})
}

exports.database.prototype.find = function(param) {
	var found=false;
	if (dataCache.length>0) {
		var ln=dataCache.length;
		for (var i=0;i<ln;i++) {
			if (dataCache[i].param===param) {
				found=true;
				break;
			}
		}
	}
	if (found) {
		return (dataCache[i].result)
	} else {
		return null;
	}

}
exports.database.prototype.complete = function(result) {
	dataCache[dataCache.length-1].result=result;
}
var dataCacheRead= function () {
	var dbFile=Ti.Database.open(databaseFile);
	var rows=dbFile.execute("SELECT param,result FROM requetes");
	var param,result;
	while (rows.isValidRow()){
  		param=rows.fieldByName('param');
  		result=rows.fieldByName('result');
  		dataCache.push({param:param,result:result});
  		rows.next();
	}
	rows.close();
	dbFile.close();
	Ti.API.info("Database  dataCacheRead:"+dataCache.length);
	return (dataCache.length);
}

var dataCacheWrite= function () {
	if (dataCache.length>nbItem) {
		var dbFile=Ti.Database.open(databaseFile);
		var row;
		for (var i=nbItem;i<dataCache.length;i++) {
			row=dbFile.execute("INSERT INTO requetes (param,result) VALUES(?,?)",dataCache[i].param,dataCache[i].result);
			Ti.API.info("Database  added param:"+dataCache[i].param+" result:"+dataCache[i].result.length);

		}
		nbItem=dataCache.length;
//		row.close();
		dbFile.close();
	}
	Ti.API.info("Database  dataCacheWrite:"+dataCache.length);
}
