var imageDir=null;
var imageByUrl=null;
var subscriber=0;
exports.imageCache = function() {
	if (imageDir==null) {
		Ti.API.info("imageCache create");
		if (Ti.Platform.name === 'android' && Ti.Filesystem.isExternalStoragePresent()) {
			imageDir= Ti.Filesystem.getFile(Ti.Filesystem.externalStorageDirectory,'utpart');
			if (! imageDir.exists()) {
	    		imageDir.createDirectory();
			} 
  			imageDir= Ti.Filesystem.getFile(imageDir.nativePath,'images');
		} else {
			imageDir = Ti.Filesystem.getFile(Ti.Filesystem.applicationDataDirectory,'images');
		}		
		            
		if (! imageDir.exists()) {
    		imageDir.createDirectory();
		} 
		imageByUrl=new Array();
		subscriber=1
	} else {
		subscriber++;
	}
	Ti.API.info("imageCache Mgr:"+subscriber);
};

exports.imageCache.prototype.getImageByUrl = function(url) {
	var imageFile  = Ti.Filesystem.getFile(imageDir.resolve(), cleanURLString(url));
	if (imageFile.exists()){
		Ti.API.info("imageCache file in cache:"+imageFile.nativePath);
		return imageFile.nativePath;
	} else {
//		if (!imageByUrl[url]) {
			Ti.API.info("imageCache file not cached:"+url);
			imageByUrl[url]=imageFile;
//		}
		return url;
	}
}

exports.imageCache.prototype.imageLoad = function(iView) {
	var url=iView.image;
	
	if (imageByUrl[url]) {
		var cachedImage = iView.toBlob();
		var res=(imageByUrl[url]).write(cachedImage);
		delete imageByUrl[url];
		Ti.API.info("imageCache file cached:"+url+" ret:"+res);
	} else {
		Ti.API.info("imageCache file error:"+url);
	}
//	iView.removeEventListener('load',imageLoaded);
}

var cleanURLString= function cleanURLString(url){
//	var hash = url.substring(url.lastIndexOf('/')+1);//MD5.hash(url);
	return (url.substring(url.lastIndexOf('/')+1));
}