var imageCacheMgr=null;
var utpaUrl="http://memento.alwaysdata.net/utpa/";
var activityIndicator = null;
var saveImageLocation=null;
var viewWidth = Ti.Platform.displayCaps.platformWidth;

function UI_Artiste() {
	var style=Ti.App.Properties.getObject('mainStyle');
	this.ui = Ti.UI.createScrollView({
			width : '100%',
			height :  '100%', 
			backgroundColor : '#fff',
			showVerticalScrollIndicator:true,
			layout: "vertical",
			scrollType:'vertical',
			top:0
		}); 
//	this.ui.setContentOffset({x:0,y:0}, {animated:false});	
	var name = Ti.UI.createLabel({
			color:'#000',
			height:50,
			backgroundColor : '#fff',
			textAlign:'center'
		});
	var title = Ti.UI.createLabel({
			color:'#000',
			height:50,
			backgroundColor : '#fff',
			textAlign:'center'
		});
		
	var image = Ti.UI.createImageView({
		width:Ti.UI.SIZE
	});
	
	var texte = Ti.UI.createTextArea({
		width:'100%',
		height: Ti.UI.SIZE,
		color:'#000',
		borderRadius:0,
		borderColor:'#fff',
		backgroundImage:'clean.png',
		textAlign:'center',
		font:style.font,
		scrollable:false,
		editable:false
	});
	
	this.ui.add(name);
	this.ui.add(title);
	this.ui.add(image);
	this.ui.add(texte);
	
	this.ui.addEventListener('update',function(event) {
		Ti.API.info("ARTISTE update()");
		
		var data=event.responseText;
		var jsonObject = JSON.parse(data);
		var id = jsonObject.id;
		var nom = jsonObject.nom;
		var url = utpaUrl + "artiste/" + id + '/' + jsonObject.image;
		var text1 = jsonObject.texte;
		var resume = jsonObject.resume;

		this.children[2].image = imageCacheMgr.getImageByUrl(url);
		Ti.API.info("ARTISTE image:" + this.children[2].image);
		if ((this.children[2].image).indexOf('http') == 0) {
			this.children[2].addEventListener('load', imageLoaded);
		}
		
		this.startLayout();
		this.children[0].text = nom;
		this.children[1].text = resume;
		this.children[3].value = text1;
//		this.setContentOffset({x:0,y:0});
		this.finishLayout();
		if (activityIndicator != null) {
			Ti.API.info("ARTISTE stop activity");
			activityIndicator.hide();
			if (Ti.Platform.name === 'iPhone OS'){
  				this.remove(activityIndicator);
			}
			activityIndicator = null;
	}

	});

	if (imageCacheMgr==null) {
		var ImageCacheMgr=require('services/imageCache').imageCache;
		imageCacheMgr=new ImageCacheMgr();
	}
	this.initDone=false;
}

var imageLoaded= function(event) {
	this.removeEventListener('load',imageLoaded);
	if (this.image==null) {
		this.image=saveImageLocation;
	}
	if (imageCacheMgr) {
		imageCacheMgr.imageLoad(this);
	}
}

UI_Artiste.prototype.init = function () {
	if (this.initDone == false) {
		var NetworkController = require('services/network').networkController;
		activityIndicator = Ti.UI.createActivityIndicator({
				width : 100,
				message : 'chargement...',
				color : '#000',
				height : 100,
				top : 100,
				style:Ti.UI.iPhone.ActivityIndicatorStyle.DARK,
				left : 100
		});
		var httpClient = new NetworkController();
		if (httpClient.send2("type=focus", this.ui) == true) {
			Ti.API.info("ARTISTE start activity");
			if (Ti.Platform.name === 'iPhone OS'){
  				this.ui.add(activityIndicator);
			}
			activityIndicator.show();
		} else {
			activityIndicator=null;
		}
		Ti.API.info("ARTISTE init send()");
		this.initDone = true;
	} else {
		Ti.API.info("ARTISTE init done");
	}
}

UI_Artiste.prototype.getUi = function () {
	return this.ui;
}

UI_Artiste.prototype.getObject = function () {
	return this;
}

UI_Artiste.prototype.dataChange = function (data) {
	var id=data.id;
	var nom=data.nom;
	var url=utpaUrl+"artiste/"+id+'/'+data.image;
	var texte=data.texte;
	var resume=data.resume;
	Ti.API.info("FOCUS id:"+id+" nom:"+nom+" url:"+url+" resume:"+resume);
//	uiArtiste.children[2].image="http://memento.alwaysdata.net/utpa/artiste/"+id+'/'+data.image;
	saveImageLocation=url;
	if (id==15) nom="Josee BERTHELET-GEREYS";
	if (id==11) nom="Francois EFFELEC";
	if (id==19) nom="Josee SALAUN";
	if (id==10) nom="celine GERVAIS-DEMELLIER";

	this.ui.children[0].text=nom;
	this.ui.children[1].text=resume;
	/*
	this.ui.children[2].image=imageCacheMgr.getImageByUrl(url);
	Ti.API.info("ARTISTE image:"+this.ui.children[2].image);
	if ((this.ui.children[2].image).indexOf('http')==0) {
		this.ui.children[2].addEventListener('load',imageLoaded);
		Ti.API.info("ARTISTE image:"+this.ui.children[2].image);
	} else {
		Ti.API.info("ARTISTE image size w:"+this.ui.children[2].size.width+" h:"+this.ui.children[2].size.height);
	}
	*/
	this.ui.children[3].value=texte;
	this.ui.children[2].image='test.png';
	Ti.API.info("ARTISTE nom:"+this.ui.children[0].text.length +" resume:"+this.ui.children[1].text.length+" texte:"+this.ui.children[3].value.length);
//	this.ui.scrollTo(0,0);
//	this.ui.setContentOffset({x:0,y:0}, {animated:false});
//		Ti.API.info("ARTISTE image size2 w:"+ui.children[2].size.width+" h:"+ui.children[2].size.height);
//	Ti.API.info("ARTISTE offset y:"+this.ui.contentOffset.y);
//	this.ui.scrollingEnabled=false;
	var Height=this.ui.children[0].size.height+this.ui.children[1].size.height+this.ui.children[2].size.height+this.ui.children[3].size.height;
	Ti.API.info("ARTISTE content size:"+Height+" view size:"+this.ui.size.height);
//	this.ui.contentHeight=Height;
}

module.exports=UI_Artiste;
