var HEADER_HEIGHT = 5;
var FOOTER_HEIGHT = 5;
var imageCacheMgr=null;
var initDone=false;
var navController=null;
var urlimage="http://memento.alwaysdata.net/utpa/";
var heightRow=120;
var activityIndicator = null;
var valueObject=null;
var saveUi=null;

function UI_ListeArtistes() {
	
//	var NavController = require('NavigationController');
//	var navControl = new NavController();
	
	this.ui = Ti.UI.createTableView({
		top: HEADER_HEIGHT,
		bottom: FOOTER_HEIGHT,
		separatorColor: '#222'
	});
	if (imageCacheMgr==null) {
		var ImageCacheMgr=require('services/imageCache').imageCache;
		imageCacheMgr=new ImageCacheMgr();
	}
	this.initDone=false;
	saveUi=this.ui; // ios 
	this.ui.addEventListener('click',artisteSelection) ;
	this.ui.addEventListener('update',function(event) {
		Ti.API.info("LISTE ARTISTES update()");
		var datas=event.responseText;
		var jsonObject = JSON.parse(datas);
		var count=jsonObject.length;
		var data=[];
		valueObject=null;
		valueObject=new Array();
		for (var c = 0; c < 2*count; c++) {
			data[c] = createRow(jsonObject[c%count]);
			valueObject.push(jsonObject[c%count]);
		}
		this.data = data;
		if (activityIndicator!=null) {
			Ti.API.info("LISTE ARTISTES stop activity");
			activityIndicator.hide();
			if (Ti.Platform.name === 'iPhone OS'){
  				this.remove(activityIndicator);
			}
			activityIndicator=null;
		}
	});
}


UI_ListeArtistes.prototype.init = function () {
	if (this.initDone==false) {
		activityIndicator = Ti.UI.createActivityIndicator({
			width : 100,
			message : 'chargement...',
			color : '#000',
			height : 100,
			top : 100,
			left : 100,
		});
		var NetworkController = require('services/network').networkController;
		var httpClient = new NetworkController();
		if (httpClient.send2("type=artistes", this.ui) == true) {
			Ti.API.info("LISTE ARTISTES start activity");
			if (Ti.Platform.name === 'iPhone OS'){
  				this.ui.add(activityIndicator);
			}
			activityIndicator.show();
		} else {
			activityIndicator=null;
		}
		Ti.API.info("LISTE ARTISTES init send()");
		this.initDone = true; 
	} else {
		Ti.API.info("LISTE ARTISTES init done");
	}
}

UI_ListeArtistes.prototype.getUi = function () {
	return this.ui;
}
UI_ListeArtistes.prototype.getObject = function () {
	return this;
}

var createRow = function(item) {
	var row = Ti.UI.createTableViewRow({ 
		className: "artisterow",
		hasChild: false,
		height: heightRow,
		touchEnabled: true
	});
	var photo = Ti.UI.createImageView({
		image: ((item.photo!="")?imageCacheMgr.getImageByUrl(urlimage+'artiste/'+item.id+'/'+item.photo):'../avatar.png'),
		height: heightRow-10,
		width: heightRow-10,
		top: 5,
		touchEnabled: false,
		left: 5
	});
	if ((photo.image).indexOf('http')==0) {
		Ti.API.info("LISTE ARTISTE waiting for loading: "+item.photo);
		photo.addEventListener('load',imageLoaded);
	}
	
	var title = Ti.UI.createLabel({ 
		text: item.nom, 
		color: '#222',
		font: {
			fontSize: 24,
			fontWeight: 'bold'	
		},
		top: 5,
		touchEnabled: false,
		left: heightRow
	});
	var subtitle = Ti.UI.createLabel({ 
		text: item.nombre+' oeuvres', 
		color: '#222',
		font: {
			fontSize: 18,
			fontWeight: 'normal'	
		},
		touchEnabled: false,
		top: 40,
		left: heightRow
	});
	row.id=item.id;
	row.image=item.image;
	row.texte=item.texte;
	row.resume=item.resume;
	row.nom=item.nom;
	row.add(photo);
	row.add(title);
	row.add(subtitle);
	return row;
};
var scrolled= function(event) {
	Ti.API.info("LISTE ARTISTES scrolled: "+event.source);

	var row,blob,rowBlobed,i=0;
	var section=this.data[0];
	var l=section.rows.length;
	for (var c = 0; c < l; c++) {
		if (section.rows[c].children.length > 1) {
			row = section.rows[c];
			blob = row.toImage();
			//row.view
			rowBlobed = Ti.UI.createImageView({
				height : heightRow,
				width : row.width,
				image : blob
			});
			row.remove(row.children[2]);
			row.remove(row.children[1]);
			row.remove(row.children[0]);
			row.add(rowBlobed);
			i++;
		}
	}
	Ti.API.info("LISTE ARTISTES end blobbling:"+i);
}
var imageLoaded= function(event) {
	if (imageCacheMgr) {
		Ti.API.info("LISTE ARTISTES image loaded: "+this.image);
		imageCacheMgr.imageLoad(this);
	}
	this.removeEventListener('load',imageLoaded);
}

var artisteSelection = function(event) {
		var viewArtisteUI = require('ui/viewArtiste');
		var viewArtiste = new viewArtisteUI(valueObject, event.index);
		var ui = viewArtiste.getUi();
		var osname = Ti.Platform.osname;
		var win=Ti.UI.createWindow({
				width:'100%', // Ti.Platform.displayCaps.platformWidth,
				height:'100%', //Ti.Platform.displayCaps.platformHeight, //Ti.UI.SIZE, //Ti.App.Properties.getInt('winHeight'),
	        	backgroundColor: '#fff',
				tabBarHidden:true
			});
		ui.top=0;
		win.add(ui);
		win.open();
}

module.exports=UI_ListeArtistes;