/**
* Appcelerator Titanium Platform
* Copyright (c) 2009-2011 by Appcelerator, Inc. All Rights Reserved.
* Licensed under the terms of the Apache Public License
* Please see the LICENSE included with this distribution for details.
**/

(function() {	

	/*	Branching logic based on OS */
	function os(/*Object*/ map) {
		var def = map.def||null; //default function or value
		if (typeof map[osname] != 'undefined') {
			if (typeof map[osname] == 'function') { return map[osname](); }
			else { return map[osname]; }
		}
		else {
			if (typeof def == 'function') { return def(); }
			else { return def; }
		}
	};
	var firstStart=false;
	var locale = Ti.Platform.locale;
	var osname = Ti.Platform.osname;
	var headerIphone=50;
	var headerAndroid=80;
	if (Ti.App.Properties.hasProperty('firstActivation')===false) {
		Ti.App.Properties.setBool('firstActivation',true);
		firstStart=true;
	}
	if (firstStart) {
		Ti.App.Properties.setInt('winHeight',os({
			iphone:Ti.Platform.displayCaps.platformHeight-93,
			android:Ti.Platform.displayCaps.platformHeight-96
		}));
		Ti.App.Properties.setInt('headerHeight',os({
			iphone:headerIphone,
			android:headerAndroid
		}));
		Ti.App.Properties.setInt('rowHeight', os({
			iphone : 120,
			android : 120
		}));
		Ti.App.Properties.setObject('mainStyle', {
			textColor : '#000000',
			grayTextColor : '#888888',
			headerColor : '#333333',
			lightBlue : '#006cb1',
			darkBlue : '#93caed',
			fontFamily : os({
				iphone : 'Helvetica Neue',
				android : 'Droid Sans'
			}),
			font : {
				fontSize : os({
					iphone : 16,
					android : 18
				}),
				fontWeight : 'normal',
				fontFamily : os({
					iphone : 'Helvetica Neue',
					android : 'Droid Sans'
				})
			}
		});

		Ti.App.Properties.setObject('buttonStyle', {
			//			backgroundImage:'',
			style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
			height : os({
				iphone : headerIphone,
				android : headerAndroid
			}),
			width : 100,
			color : '#000',
			backgroundColor : '#aaa',
			font : {
				fontSize : os({
					iphone : 20,
					android : 24
				}),
				fontWeight : 'bold',
				fontFamily : os({
					iphone : 'Helvetica Neue',
					android : 'Droid Sans'
				})
			}
		});

		Ti.App.Properties.setObject('labelStyle', {
			color : '#000000',
			font : {
				fontFamily : os({
					iphone : 'Helvetica Neue',
					android : 'Droid Sans'
				}),
				fontWeight : 'bold',
				fontSize : os({
					iphone : 20,
					android : 24
				})
			},
			backgroundColor : '#fff',
			textAlign : 'center',
			width : '100%',
			height : 'auto'
		}); 
	}
		// Window: {
			// backgroundImage:'',
			// navBarHidden:true,
			// softInputMode:(Ti.UI.Android) ? Ti.UI.Android.SOFT_INPUT_ADJUST_RESIZE : ''
		// },
		// /*
		// TableView: {
			// backgroundImage:'',
			// separatorStyle:global.os({
					// iphone:Ti.UI.iPhone.TableViewSeparatorStyle.NONE
				// })
		// },
		// */
		// TableViewRow: {
			// backgroundImage:'',
			// selectedBackgroundColor: global.theme.darkBlue, //I know, this is dumb, but it's currently inconsistent x-platform
			// backgroundSelectedColor: global.theme.darkBlue,
			// //height:110,
			// className:'tvRow'
		// },
		// TextField: {
			// height:55,
			// borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
			// color:'#000000'
		// },
		// TextArea: {
			// borderRadius:0,
			// backgroundColor:'#fff',
			// //gradient will only work on iOS
			// backgroundGradient:{
				// type:'linear',
				// colors:[
					// {color:'#efefef',position:0.0},
					// {color:'#cdcdcd',position:0.50},
					// {color:'#efefef',position:1.0}
				// ]
			// },
			// color:global.theme.textColor,
			// textAlign:'center'
		// },
// 		
		// //we use these as JS-based 'style classes'
		// animationDuration: 500,
		// stretch: {
			// top:0,bottom:0,left:0,right:0
		// },
		// variableTopRightButton: {
			// top:5,
			// right:5,
			// height:30,
			// width:global.os({
				// iphone:60,
				// android:'auto'
			// }),
			// color:'#ffffff',
			// font: {
				// fontSize:12,
				// fontWeight:'bold'
			// },
			// backgroundImage:''
		// },
		// topRightButton: {
			// top:5,
			// right:5,
			// height:30,
			// width:38
		// },
		// headerText: {
			// top:8,
			// height:'auto',
			// textAlign:'center',
			// color:global.theme.headerColor,
			// font: {
				// fontFamily:global.theme.fontFamily,
				// fontSize:18,
				// fontWeight:'bold'
			// }
		// },
		// headerView: {
			// backgroundImage:'',
			// height:40
		// },
		// boldHeaderText: {
			// height:'auto',
			// color:'#000000',
			// font: {
				// fontFamily:global.theme.fontFamily,
				// fontSize:14,
				// fontWeight:'bold'
			// }
		// },
		// smallText: {
			// color:global.theme.grayTextColor,
			// font: {
				// fontFamily:global.theme.fontFamily,
				// fontSize:10
			// },
			// height:'auto'
		// },
		// spacerRow: {
			// backgroundImage:'',
			// height:30,
			// className:'spacerRow'
		// }
	// };
})();

